package com.fr.plugin.sqy.surface.chart;

import com.fr.extended.chart.AbstractDataConfig;
import com.fr.extended.chart.ExtendedField;
import com.fr.stable.AssistUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

public class ChartDataConfig extends AbstractDataConfig {

    private ExtendedField x = new ExtendedField();
    private ExtendedField y = new ExtendedField();
    private ExtendedField z = new ExtendedField();
    private String tarName;


    public ExtendedField getX() {
        return x;
    }

    public void setX(ExtendedField x) {
        this.x = x;
    }

    public ExtendedField getY() {
        return y;
    }

    public void setY(ExtendedField y) {
        this.y = y;
    }

    public ExtendedField getZ() {
        return z;
    }

    public void setZ(ExtendedField z) {
        this.z = z;
    }

    public String getTarName() {
        return tarName;
    }

    public void setTarName(String tarName) {
        this.tarName = tarName;
    }


    @Override
    protected void readAttr(XMLableReader xmLableReader) {
        readExtendedField(x, "x", xmLableReader);
        readExtendedField(y, "y", xmLableReader);
        readExtendedField(z, "z", xmLableReader);
        setTarName(xmLableReader.getAttrAsString("tarName",""));

    }

    @Override
    protected void writeAttr(XMLPrintWriter xmlPrintWriter) {
        writeExtendedField(x, "x", xmlPrintWriter);
        writeExtendedField(y, "y", xmlPrintWriter);
        writeExtendedField(z, "z", xmlPrintWriter);
        xmlPrintWriter.attr("tarName",getTarName());
    }

    @Override
    public ExtendedField[] dataSetFields() {
        return new ExtendedField[]{
                x,
                y,
                z
        };
    }

    @Override
    public AbstractDataConfig clone() throws CloneNotSupportedException {
        ChartDataConfig result = (ChartDataConfig)super.clone();
        result.setX(getX().clone());
        result.setY(getY().clone());
        result.setZ(getZ().clone());
        result.setTarName(getTarName());
        return result;
    }

    @Override
    public int hashCode() {
        return super.hashCode()+ AssistUtils.hashCode(getX(),getY(),getZ(),getTarName());
    }

    @Override
    public boolean equals(Object o) {
        return o instanceof ChartDataConfig
                && super.equals(o)
                && AssistUtils.equals(getX(),((ChartDataConfig)o).getX())
                && AssistUtils.equals(getY(),((ChartDataConfig)o).getY())
                && AssistUtils.equals(getZ(),((ChartDataConfig)o).getZ())
                && AssistUtils.equals(getTarName(),((ChartDataConfig)o).getTarName());
    }
}
