package com.fr.plugin.sqy.surface.config;


import com.fr.extended.chart.StringFormula;
import com.fr.stable.StringUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

public class AxisConfig implements ConfigProvider{
    private String id;
    private StringFormula name  = new StringFormula();
    private String type;
    private String nameLocation;
    private StringFormula min = new StringFormula();
    private StringFormula max  = new StringFormula();
    private final LabelConfig nameTextStyle = new LabelConfig("nameTextStyle");
    private final LabelConfig axisLabel = new LabelConfig("axisLabel");
    private final ShowConfig axisTick = new ShowConfig("axisTick");
    private final LineStyleConfig axisLine = new LineStyleConfig("axisLine");
    private final LineStyleConfig splitLine = new LineStyleConfig("splitLine");

    private AxisConfig() {
    }

    public AxisConfig(String id) {
        this.id = id;
    }


    public StringFormula getMin() {
        return min;
    }

    public void setMin(StringFormula min) {
        this.min = min;
    }

    public StringFormula getMax() {
        return max;
    }

    public void setMax(StringFormula max) {
        this.max = max;
    }

    public String getId() {
        return id;
    }

    public StringFormula getName() {
        return name;
    }

    public String getType() {
        return type;
    }

    public String getNameLocation() {
        return nameLocation;
    }

    public LabelConfig getNameTextStyle() {
        return nameTextStyle;
    }

    public LabelConfig getAxisLabel() {
        return axisLabel;
    }

    public ShowConfig getAxisTick() {
        return axisTick;
    }

    public LineStyleConfig getAxisLine() {
        return axisLine;
    }

    public LineStyleConfig getSplitLine() {
        return splitLine;
    }

    public void setName(StringFormula name) {
        this.name = name;
    }

    public void setType(String type) {
        this.type = type;
    }

    public void setNameLocation(String nameLocation) {
        this.nameLocation = nameLocation;
    }


    private String concatName(String name1,String name2){
        if(StringUtils.isBlank(name2)){
            return name1 + "_" + this.getId();
        }
        return name1 + "_" + this.getId() + "_" + name2;
    }


    @Override
    public void writeAttr(String var1, XMLPrintWriter var2) {
        var2.attr(concatName(var1,"name"),this.getName().getContent());
        var2.attr(concatName(var1,"type"),this.getType());
        var2.attr(concatName(var1,"nameLocation"),this.getNameLocation());
        var2.attr(concatName(var1,"min"),this.getMin().getContent());
        var2.attr(concatName(var1,"max"),this.getMax().getContent());
        this.getNameTextStyle().writeAttr(concatName(var1,""),var2);
        this.getAxisLabel().writeAttr(concatName(var1,""),var2);
        this.getAxisTick().writeAttr(concatName(var1,""),var2);
        this.getAxisLine().writeAttr(concatName(var1,""),var2);
        this.getSplitLine().writeAttr(concatName(var1,""),var2);
    }

    @Override
    public void readAttr(String var1, XMLableReader var2) {
        this.getName().setContent(var2.getAttrAsString(concatName(var1,"name"),""));
        this.setType(var2.getAttrAsString(concatName(var1,"type"),""));
        this.setNameLocation(var2.getAttrAsString(concatName(var1,"nameLocation"),""));
        this.getMin().setContent(var2.getAttrAsString(concatName(var1,"min"),""));
        this.getMax().setContent(var2.getAttrAsString(concatName(var1,"max"),""));
        this.getNameTextStyle().readAttr(concatName(var1,""),var2);
        this.getAxisLabel().readAttr(concatName(var1,""),var2);
        this.getAxisTick().readAttr(concatName(var1,""),var2);
        this.getAxisLine().readAttr(concatName(var1,""),var2);
        this.getSplitLine().readAttr(concatName(var1,""),var2);

    }
}
