package com.fr.plugin.sqy.surface.config;

import com.fr.plugin.sqy.surface.util.PluginStringUtils;
import com.fr.stable.StringUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

import java.awt.*;

public class LabelConfig implements ConfigProvider{
    private String id;
    private boolean show;
    private Color color  = new Color(0x000000);
    private int fontSize;
    private String formatter;

    private LabelConfig(){

    }

    public LabelConfig(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public boolean isShow() {
        return show;
    }

    public void setShow(boolean show) {
        this.show = show;
    }

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public int getFontSize() {
        return fontSize;
    }

    public void setFontSize(int fontSize) {
        this.fontSize = fontSize;
    }

    public String getFormatter() {
        return formatter;
    }

    public void setFormatter(String formatter) {
        this.formatter = formatter;
    }

    private String concatName(String name1, String name2){
        if(StringUtils.isBlank(name2)){
            return name1 + "_" + this.getId();
        }
        return name1 + "_" + this.getId() + "_" + name2;
    }

    @Override
    public void writeAttr(String var1, XMLPrintWriter var2) {
        var2.attr(concatName(var1,"show"),this.isShow());
        var2.attr(concatName(var1,"color"), this.getColor().getRGB());
        var2.attr(concatName(var1,"fontSize"),this.getFontSize());
        var2.attr(concatName(var1,"formatter"),this.getFormatter());
    }

    @Override
    public void readAttr(String var1, XMLableReader var2) {
        this.setShow(var2.getAttrAsBoolean(concatName(var1,"show"),true));
        this.setColor(new Color(var2.getAttrAsInt(concatName(var1,"color"),new Color(0x000000).getRGB())));
        this.setFontSize(var2.getAttrAsInt(concatName(var1,"fontSize"),0));
        this.setFormatter(var2.getAttrAsString(concatName(var1,"formatter"),""));
    }
}
