package com.fr.plugin.sqy.surface.config;

import com.fr.stable.StringUtils;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

import java.awt.*;

public class LineStyleConfig implements ConfigProvider{
    private String id;
    private Color color = new Color(0x000000);
    private double width;
    private String type;

    private LineStyleConfig() {
    }

    public LineStyleConfig(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public double getWidth() {
        return width;
    }

    public void setWidth(double width) {
        this.width = width;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    private String concatName(String name1,String name2){
        if(StringUtils.isBlank(name2)){
            return name1 + "_" + this.getId();
        }
        return name1 + "_" + this.getId() + "_" + name2;
    }

    @Override
    public void writeAttr(String var1, XMLPrintWriter var2) {
        var2.attr(concatName(var1,"color"),this.getColor().getRGB());
        var2.attr(concatName(var1,"width"),this.getWidth());
        var2.attr(concatName(var1,"type"),this.getType());
    }

    @Override
    public void readAttr(String var1, XMLableReader var2) {
        this.setColor(new Color(var2.getAttrAsInt(concatName(var1,"color"),new Color(0x000000).getRGB())));
        this.setWidth(var2.getAttrAsDouble(concatName(var1,"width"),1D));
        this.setType(var2.getAttrAsString(concatName(var1,"type"),""));
    }
}
