package com.fr.plugin.sqy.surface.option;

import com.fanruan.api.json.JSONKit;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.sqy.surface.option.modle.OptionProvider;
import com.fr.plugin.sqy.surface.zenum.AxisTypeEnum;
import com.fr.stable.StringUtils;

import java.util.List;

/**
 * 坐标轴
 */
public class Axis3D implements OptionProvider {
    /**
     * 坐标轴类型
     */
    private String type;
    /**
     * 坐标轴名称
     */
    private String name;
    /**
     * 坐标轴名称位置
     */
    private String nameLocation;

    /**
     * 坐标轴值 类目数据，在类目轴（type: 'category'）中有效。
     */
    private List<Object> data;

    private Double min;

    private Double max;

    private boolean boundaryGap = true;

    private LabelStyle nameTextStyle;

    private LabelStyle axisLabel;

    private AxisTick axisTick;

    private AxisLine axisLine;

    private SplitLine splitLine;


    public Double getMin() {
        return min;
    }

    public void setMin(Double min) {
        this.min = min;
    }

    public Double getMax() {
        return max;
    }

    public void setMax(Double max) {
        this.max = max;
    }

    public boolean isBoundaryGap() {
        return boundaryGap;
    }

    public void setBoundaryGap(boolean boundaryGap) {
        this.boundaryGap = boundaryGap;
    }

    public LabelStyle getNameTextStyle() {
        return nameTextStyle;
    }

    public void setNameTextStyle(LabelStyle nameTextStyle) {
        this.nameTextStyle = nameTextStyle;
    }

    public LabelStyle getAxisLabel() {
        return axisLabel;
    }

    public void setAxisLabel(LabelStyle axisLabel) {
        this.axisLabel = axisLabel;
    }

    public AxisTick getAxisTick() {
        return axisTick;
    }

    public void setAxisTick(AxisTick axisTick) {
        this.axisTick = axisTick;
    }

    public AxisLine getAxisLine() {
        return axisLine;
    }

    public void setAxisLine(AxisLine axisLine) {
        this.axisLine = axisLine;
    }

    public SplitLine getSplitLine() {
        return splitLine;
    }

    public void setSplitLine(SplitLine splitLine) {
        this.splitLine = splitLine;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getNameLocation() {
        return nameLocation;
    }

    public void setNameLocation(String nameLocation) {
        this.nameLocation = nameLocation;
    }

    public List<Object> getData() {
        return data;
    }

    public void setData(List<Object> data) {
        this.data = data;
    }

    public JSONObject getJSONObject(){
        JSONObject axis3D = JSONKit.create();
        axis3D.put("type",AxisTypeEnum.parseString(this.getType()).getName());
        axis3D.put("name",this.getName());
        if(this.getData() != null){
            JSONArray dataJSONArray = JSONKit.createJSONArray();
            for (int i = 0; i < data.size(); i++) {
                dataJSONArray.put(data.get(i));
            }
            axis3D.put("data",dataJSONArray);
        }
        axis3D.put("boundaryGap",this.isBoundaryGap());
        if(this.getAxisLabel() != null){
            axis3D.put("axisLabel",this.getAxisLabel().getJSONObject());
        }
        if(this.getAxisTick() != null){
            axis3D.put("axisTick",this.getAxisTick().getJSONObject());
        }
        if(this.getAxisLine() != null){
            axis3D.put("axisLine",this.getAxisLine().getJSONObject());
        }
        if(this.getSplitLine() != null){
            axis3D.put("splitLine",this.getSplitLine().getJSONObject());
        }
        if(this.getNameTextStyle() != null){
            axis3D.put("nameTextStyle",this.getNameTextStyle().getJSONObject());
        }
        if(this.getMax() != null){
            axis3D.put("max",this.getMax());
        }
        if(this.getMin() != null){
            axis3D.put("min",this.getMin());
        }
        return axis3D;
    }
}
