package com.fr.plugin.sqy.surface.option;

import com.fanruan.api.json.JSONKit;
import com.fr.json.JSONObject;
import com.fr.plugin.sqy.surface.option.modle.OptionProvider;

public class AxisLine implements OptionProvider {
    private boolean show = true;
    private LineStyle lineStyle;

    public AxisLine() {
    }

    public AxisLine(boolean show) {
        this.show = show;
    }

    public AxisLine(boolean show, LineStyle lineStyle) {
        this.show = show;
        this.lineStyle = lineStyle;
    }

    public boolean isShow() {
        return show;
    }

    public void setShow(boolean show) {
        this.show = show;
    }

    public LineStyle getLineStyle() {
        return lineStyle;
    }

    public void setLineStyle(LineStyle lineStyle) {
        this.lineStyle = lineStyle;
    }

    @Override
    public JSONObject getJSONObject() {
        JSONObject axisLine = JSONKit.create();
        axisLine.put("show",this.isShow());
        if(this.getLineStyle() != null){
            axisLine.put("lineStyle",this.getLineStyle().getJSONObject());
        }
        return axisLine;
    }
}
