package com.fr.plugin.sqy.surface.option;

import com.fanruan.api.json.JSONKit;
import com.fr.json.JSONObject;
import com.fr.plugin.sqy.surface.option.modle.OptionProvider;
import com.fr.plugin.sqy.surface.util.PluginStringUtils;
import com.fr.stable.StringUtils;

import java.awt.*;

public class LabelStyle implements OptionProvider {
    private Color color;
    private int fontsize;
    private String formatter;

    public LabelStyle() {
    }

    public LabelStyle(Color color, int fontsize) {
        this.color = color;
        this.fontsize = fontsize;
    }

    public String getFormatter() {
        return formatter;
    }

    public void setFormatter(String formatter) {
        this.formatter = formatter;
    }

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public int getFontsize() {
        return fontsize;
    }

    public void setFontsize(int fontsize) {
        this.fontsize = fontsize;
    }

    @Override
    public JSONObject getJSONObject() {
        JSONObject labelStyle = JSONKit.create();
        if(this.getColor() != null){
            labelStyle.put("color", PluginStringUtils.colorToString(this.getColor()));
        }
        if(this.getFontsize() != 0){
            labelStyle.put("fontSize",this.getFontsize());
        }
        if(StringUtils.isNotBlank(this.getFormatter())){
            labelStyle.put("formatter",this.getFormatter());
        }
        return labelStyle;
    }
}
