package com.fr.plugin.sqy.surface.option;

import com.fanruan.api.json.JSONKit;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.sqy.surface.option.modle.OptionProvider;
import com.fr.stable.StringUtils;

import java.util.List;

public class Series implements OptionProvider {
    private String type = "surface";
    private List<Object> data;
    private String name;
    private Wireframe wireframe;


    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public List<Object> getData() {
        return data;
    }

    public void setData(List<Object> data) {
        this.data = data;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Wireframe getWireframe() {
        return wireframe;
    }

    public void setWireframe(Wireframe wireframe) {
        this.wireframe = wireframe;
    }

    public JSONObject getJSONObject(){
        JSONObject series = JSONKit.create();
        series.put("type",this.getType());
        JSONArray dataJSONArray = JSONKit.createJSONArray();
        if(this.getData() != null){
            for (int i = 0; i < data.size(); i++) {
                dataJSONArray.put(data.get(i));
            }
        }
        series.put("data",dataJSONArray);
        if(!StringUtils.isBlank(this.getName())){
            series.put("name",this.getName());
        }
        if(this.getWireframe() != null){
            series.put("wireframe",this.getWireframe().getJSONObject());
        }
        return series;
    }

}
