package com.fr.plugin.sqy.surface.pane;

import com.fr.design.formula.TinyFormulaPane;
import com.fr.design.gui.itextfield.UITextField;
import com.fr.extended.chart.AbstractExtendedChartReportDataPane;
import com.fr.plugin.sqy.surface.chart.ChartDataConfig;

import java.awt.*;

public class ReportDataPane extends AbstractExtendedChartReportDataPane<ChartDataConfig> {

    private TinyFormulaPane xPane;
    private TinyFormulaPane yPane;

    @Override
    protected boolean hasCustomFieldPane() {
        return true;
    }

    @Override
    protected String[] fieldLabel() {
        return new String[]{
                "X轴",
                "Y轴"
        };
    }

    @Override
    protected Component[] fieldComponents() {
        if (xPane == null) {
            xPane = new TinyFormulaPane();
            yPane = new TinyFormulaPane();
        }
        return new Component[]{
                xPane,
                yPane
        };
    }

    @Override
    protected TinyFormulaPane[] formulaPanes() {
        if (xPane == null) {
            xPane = new TinyFormulaPane();
            yPane = new TinyFormulaPane();
        }
        return new TinyFormulaPane[]{
                xPane,
                yPane
        };
    }

    @Override
    protected void populate(ChartDataConfig chartDataConfig) {
        populateField(xPane, chartDataConfig.getX());
        populateField(yPane, chartDataConfig.getY());

    }

    @Override
    protected ChartDataConfig update() {
        ChartDataConfig dataConfig = new ChartDataConfig();
        updateField(xPane, dataConfig.getX());
        updateField(yPane, dataConfig.getY());
        return dataConfig;
    }

}
