package com.fr.plugin.sqy.surface.pane;

import com.fr.design.gui.icombobox.UIComboBox;
import com.fr.extended.chart.AbstractExtendedChartTableDataPane;
import com.fr.extended.chart.ExtendedCustomFieldComboBoxPane;
import com.fr.plugin.sqy.surface.chart.ChartDataConfig;

import java.awt.*;

public class TableDataPane extends AbstractExtendedChartTableDataPane<ChartDataConfig> {

    private UIComboBox xComboBox;
    private UIComboBox yComboBox;

    @Override
    protected ExtendedCustomFieldComboBoxPane createExtendedCustomFieldComboBoxPane() {
        return new ExtendedCustomFieldComboBoxPane();
    }


    @Override
    protected String[] fieldLabels() {
        return new String[]{
                "X轴",
                "Y轴"
        };
    }

    @Override
    protected Component[] fieldComponents() {
        if (xComboBox == null) {
            xComboBox = new UIComboBox();
            yComboBox = new UIComboBox();
        }
        return new Component[]{
                xComboBox,
                yComboBox
        };
    }

    @Override
    protected UIComboBox[] filedComboBoxes() {
        if (xComboBox == null) {
            xComboBox = new UIComboBox();
            yComboBox = new UIComboBox();
        }
        return new UIComboBox[]{
                xComboBox,
                yComboBox
        };
    }

    @Override
    protected void populate(ChartDataConfig chartDataConfig) {
        populateField(xComboBox, chartDataConfig.getX());
        populateField(yComboBox, chartDataConfig.getY());
    }

    @Override
    protected ChartDataConfig update() {
        ChartDataConfig dataConfig = new ChartDataConfig();
        updateField(xComboBox, dataConfig.getX());
        updateField(yComboBox, dataConfig.getY());
        return dataConfig;
    }
}
