package com.fr.plugin.sqy.surface.provider;

import com.fr.design.gui.frpane.AttributeChangeListener;
import com.fr.design.mainframe.chart.AbstractChartAttrPane;
import com.fr.design.mainframe.chart.gui.data.report.AbstractReportDataContentPane;
import com.fr.design.mainframe.chart.gui.type.AbstractChartTypePane;
import com.fr.extended.chart.AbstractExtendedChartTableDataPane;
import com.fr.extended.chart.AbstractExtendedChartUIProvider;
import com.fr.extended.chart.ExtendedOtherPane;
import com.fr.plugin.sqy.surface.pane.ReportDataPane;
import com.fr.plugin.sqy.surface.pane.StylePane;
import com.fr.plugin.sqy.surface.pane.TableDataPane;
import com.fr.plugin.sqy.surface.pane.TypePane;

public class ChartUIProvider extends AbstractExtendedChartUIProvider {
    @Override
    protected AbstractExtendedChartTableDataPane getTableDataSourcePane() {
        return new TableDataPane();
    }

    @Override
    protected AbstractReportDataContentPane getReportDataSourcePane() {
        return new ReportDataPane();
    }

    @Override
    public String[] getDemoImagePath() {
        return new String[]{
                "com/fr/plugin/sqy/surface/img/face.png"
        };
    }

    @Override
    public String getIconPath() {
        return "com/fr/plugin/sqy/surface/img/icon.png";
    }

    //类型配置面板
    @Override
    public AbstractChartTypePane getPlotTypePane() {
        return new TypePane();
    }

    @Override
    public AbstractChartAttrPane[] getAttrPaneArray(AttributeChangeListener attributeChangeListener) {
        return new AbstractChartAttrPane[]{
                new StylePane(attributeChangeListener),
                new ExtendedOtherPane()
        };
    }

}
