package com.fr.plugin.sqy.surface.zenum;


import com.fr.stable.StringUtils;

public enum AxisTypeEnum {
    VALUE("value"),
    CATEGORY("category"),
    TIME("time"),
    LOG("log");

    private final String name;

    public static AxisTypeEnum parseInt(int index) {
        for (AxisTypeEnum type : AxisTypeEnum.values()) {
            if (type.ordinal() == index) {
                return type;
            }
        }
        return VALUE;
    }

    public static AxisTypeEnum parseString(String str) {
        for (AxisTypeEnum type : AxisTypeEnum.values()) {
            if (StringUtils.equals(type.getName(),str)) {
                return type;
            }
        }
        return VALUE;
    }

    AxisTypeEnum(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }
}
