package com.fr.plugin.sqy.surface.zenum;

import com.fr.plugin.sqy.surface.chart.ChartType;
import com.fr.stable.StringUtils;

public enum LineTypeEnum {
    NONE("none"),
    SOLID("solid"),
    DASHED("dashed"),
    DOTTED("dotted");

    private final String name;

    LineTypeEnum(String name) {
        this.name = name;
    }

    public static LineTypeEnum parseInt(int index) {
        for (LineTypeEnum type : LineTypeEnum.values()) {
            if (type.ordinal() == index) {
                return type;
            }
        }
        return SOLID;
    }

    public static LineTypeEnum parseString(String str) {
        for (LineTypeEnum type : LineTypeEnum.values()) {
            if (StringUtils.equals(type.getName(),str)) {
                return type;
            }
        }
        return SOLID;
    }

    public String getName() {
        return name;
    }
}
