surfaceWrapper = ExtendedChart.extend({
    _init: function (dom, option) {
        const myChart = echarts.init(dom);
        if(option.data.xAxis3D.axisLabel.formatter !== undefined){
            let fmt = "(function(value,index){"+option.data.xAxis3D.axisLabel.formatter+"})(value,index)";
            option.data.xAxis3D.axisLabel.formatter = function(value,index){return eval(fmt)};
        }
        if(option.data.yAxis3D.axisLabel.formatter !== undefined){
            let fmt = "(function(value,index){"+option.data.yAxis3D.axisLabel.formatter+"})(value,index)";
            option.data.yAxis3D.axisLabel.formatter = function(value,index){return eval(fmt)};
        }
        if(option.data.zAxis3D.axisLabel.formatter !== undefined){
            let fmt = "(function(value,index){"+option.data.zAxis3D.axisLabel.formatter+"})(value,index)";
            option.data.zAxis3D.axisLabel.formatter = function(value,index){return eval(fmt)};
        }
        //console.log(option.data);
        option.data && myChart.setOption(option.data);
        myChart.on('click', function (params) {
            const links = option.links;
            for(let i = 0;i < links.length;i++){
                if(links[i].type === "javascript"){
                    let script = links[i].script;
                    script = script.substring(1,script.length-1).replace(/\\n/g,"").replace(/\\"/g,"\"");
                    script = script.replace(/FR.formulaEvaluator\("=X",[^\(\)]*,false\)/g,'FR.formulaEvaluator("=X",'+JSON.stringify(params.value[0])+',false)');
                    script = script.replace(/FR.formulaEvaluator\("=Y",[^\(\)]*,false\)/g,'FR.formulaEvaluator("=Y",'+JSON.stringify(params.value[1])+',false)');
                    script = script.replace(/FR.formulaEvaluator\("=Z",[^\(\)]*,false\)/g,'FR.formulaEvaluator("=Z",'+JSON.stringify(params.value[2])+',false)');
                    script = script.replace(/FR.formulaEvaluator\("=SERIES_NAME",[^\(\)]*,false\)/g,'FR.formulaEvaluator("=SERIES_NAME",'+JSON.stringify(params.seriesName)+',false)');
                    eval(script);
                }
            }
        });
        return myChart;
    },

    _refresh: function (chart, option) {
        if(option.data.xAxis3D.axisLabel.formatter !== undefined){
            let fmt = "(function(value,index){"+option.data.xAxis3D.axisLabel.formatter+"})(value,index)";
            option.data.xAxis3D.axisLabel.formatter = function(value,index){return eval(fmt)};
        }
        if(option.data.yAxis3D.axisLabel.formatter !== undefined){
            let fmt = "(function(value,index){"+option.data.yAxis3D.axisLabel.formatter+"})(value,index)";
            option.data.yAxis3D.axisLabel.formatter = function(value,index){return eval(fmt)};
        }
        if(option.data.zAxis3D.axisLabel.formatter !== undefined){
            let fmt = "(function(value,index){"+option.data.zAxis3D.axisLabel.formatter+"})(value,index)";
            option.data.zAxis3D.axisLabel.formatter = function(value,index){return eval(fmt)};
        }
        //console.log(option.data);
        option.data && chart.setOption(option.data);
    },

    _resize: function (chart) {
        chart.resize();
    },

    _exportInit:function (dom, option) {
        option.animation = false;
        return this._init(dom, option.data);
    },

    _exportImage: function (chart) {
        return chart.getConnectedDataURL({type: 'png'})
    }

});